<template>
    <v-layout>
        <v-flex xs12>
            <v-layout column>

                <div class="app-page-title grey lighten-4">
                    <div class="page-title-wrapper">
                        <div class="page-title-heading">
                            <div class="page-title-icon">
                                <v-img src="https://cdn.vuetifyjs.com/images/logos/logo.svg" alt="Vuetify"></v-img>
                            </div>
                            <div>
                                Menu
                                <div class="page-title-subheading">
                                    <div class="breadcrumbs">
                                        <v-breadcrumbs :items="itembreadcrumbs" style="padding:0">
                                            <template v-slot:item="props">
                                            <v-breadcrumbs-item
                                                :to="{name : props.item.href }"
                                                :class="[props.item.disabled && 'disabled']"
                                            >
                                                {{ props.item.text.toUpperCase() }}
                                            </v-breadcrumbs-item>
                                            </template>
                                        </v-breadcrumbs>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <div class="page-title-actions">
                            <div class="my-2">
                                <v-btn color="primary" dark class="mb-2" @click="addItem()">
                                    <v-icon left dark>mdi-plus-box</v-icon> Tambah
                                </v-btn>
                            </div>
                        </div>

                    </div>
                </div>
                
                <br />

                <v-card>
                    <v-card-title>
                        List Menu
                        <v-spacer></v-spacer>
                        
                        <v-text-field
                            v-model="search"
                            append-icon="search"
                            label="Search"
                            single-line
                            hide-details
                            >
                        </v-text-field>

                    </v-card-title>

                    <v-data-table
                        :headers="headers"
                        :items="itemsmenus"
                        :search="search">
                        
                        <!-- <template slot="items" slot-scope="props">
                            <td>{{ props.item.name }}</td>
                            <td class="text-xs-right">{{ props.item.calories }}</td>
                            <td class="text-xs-right">{{ props.item.fat }}</td>
                            <td class="text-xs-right">{{ props.item.carbs }}</td>
                            <td class="text-xs-right">{{ props.item.protein }}</td>
                        </template> -->

                        <template v-slot:item.pic="{ item }">
                            <v-img :src="item.pic" :alt="item.name" width="200px"></v-img>
                        </template>

                        <template v-slot:item.markup_gofood="{ item }">
                            <v-chip v-if="item.markup_gofood == 1" class="ma-2" color="green darken-4" text-color="white" small>
                                Gojek
                            </v-chip>
                            <v-chip v-if="item.markup_grabfood == 2" class="ma-2" color="green" text-color="white" small>
                                Grab
                            </v-chip>
                        </template>
                        <template v-slot:item.action="{ item }">
                            <v-icon small class="mr-2" @click="editItem(item)">
                                edit
                            </v-icon>
                            <v-icon small @click="deleteItem(item, 'no')">
                                delete
                            </v-icon>

                        </template>

                    </v-data-table>

                </v-card>

                <v-row justify="center">

                    <v-dialog v-model="dialog" persistent max-width="600px">
                        <v-card>
                            <v-card-title>
                                <span class="headline">{{ formTitle }}</span>
                            </v-card-title>

                            <v-form
                                ref="form"
                                v-model="valid"
                                :lazy-validation="lazy"
                                
                            >
                                
                                <v-card-text>
                                    <v-container>
                                        <v-row>
                                            <v-col cols="12" sm="12" md="12">
                                                <v-text-field v-model="editedItem.name" label="Name"></v-text-field>
                                            </v-col>
                                            <v-col cols="12" sm="12" md="6">
                                                <v-text-field type="number" v-model="editedItem.price" label="Price"></v-text-field>
                                            </v-col>
                                            <v-col cols="12" sm="12" md="6">
                                                <v-text-field type="number" v-model="editedItem.disc" label="Diskon"></v-text-field>
                                            </v-col>
                                            <v-col cols="12" sm="12" md="6">
                                                <v-select
                                                item-text="name"
                                                item-value="id"
                                                v-model="editedItem.id_menucategory"
                                                :items="itemmenucategories"
                                                label="Kategori"
                                                required
                                                ></v-select>
                                            </v-col>
                                            <v-col cols="12" sm="12" md="6">
                                                <!-- <v-autocomplete
                                                item-text="name"
                                                item-value="id"
                                                v-model="editedItem.supportojol"
                                                :items="itemsupportonlines"
                                                label="Support Ojol"
                                                multiple
                                                ></v-autocomplete>-->
                                                <v-autocomplete
                                                    item-text="name"
                                                    item-value="id"
                                                    :value="itemsupportonlines.id"
                                                    v-model="supportojol"
                                                    :items="itemsupportonlines"
                                                    label="Support Ojol"
                                                    @change="onCheckChanged"
                                                    multiple
                                                ></v-autocomplete>
                                            </v-col>
                                            <v-col cols="12" sm="12" md="12">
                                                <v-file-input
                                                    :rules="rules"
                                                    accept="image/png, image/jpeg, image/bmp"
                                                    placeholder="Pick an avatar"
                                                    prepend-icon="mdi-camera"
                                                    label="Avatar"
                                                    @change="onFileChanged"
                                                ></v-file-input>

                                                <!-- <v-card class="mx-auto" max-width="400" v-if="imageUrl != ''">
                                                    <v-img class="white--text align-end" height="200px" :src="imageUrl">
                                                    </v-img>
                                                </v-card> -->

                                            </v-col>
                                            
                                            <v-col cols="12" sm="12" md="12">
                                                <v-text-field v-model="editedItem.description" label="Description"></v-text-field>
                                            </v-col>
                                            
                                        </v-row>
                                    </v-container>
                                </v-card-text>

                                <v-card-actions>
                                    <v-spacer></v-spacer>
                                    <v-btn color="blue darken-1" text @click="close">Cancel</v-btn>
                                    <v-btn color="primary" :loading="btnLoading" @click="save">{{formBtnTitle}}</v-btn>
                                </v-card-actions>

                            </v-form>
                        </v-card>
                    </v-dialog>
                    
                    <v-dialog v-model="dialogDelete" persistent max-width="290">
                        <v-card>
                            <v-card-title class="headline">Hapus data?</v-card-title>
                            <v-card-text>
                                Data <b><i>{{itemTemp.name}}</i></b> akan terhapus permanent apa anda yakin ?
                            </v-card-text>
                            <v-card-actions>
                                <v-spacer></v-spacer>
                                <v-btn color="primary darken-1" text @click="dialogDelete = false">Cancel</v-btn>
                                <v-btn color="red darken-1" text :loading="btnLoading" @click="deleteItem(itemTemp, 'ok')">OK</v-btn>
                            </v-card-actions>
                        </v-card>
                    </v-dialog>
                </v-row>  
                
            </v-layout>
        </v-flex>
    </v-layout>
</template>

<script>
    export default {
        
        data: () => ({
            valid: true,
            lazy: false,
            supportojol:[],
            rules: [
                value => !value || value.size < 2000000 || 'Ukuran Gambar harus kurang dari 2 MB!',
            ],
            values: null,
            itemstest: ['foo', 'bar', 'fizz', 'buzz'],
            btnLoading: false,
            itemTemp:[],
            search: '',
            headers: [
                { text: 'Pic', value: 'pic' },
                { text: 'Nama', align: 'left', value: 'name',},
                { text: 'Description', value: 'description' },
                { text: 'Support Ojol', value: 'markup_gofood' },
                { text: 'Actions', value: 'action', sortable: false },
            ], 
            itembreadcrumbs: [
                {
                    text: 'Dashboard',
                    disabled: false,
                    href: 'dashboard',
                },
                {
                    text: 'Menu',
                    disabled: true,
                    href: 'menu',
                },
            ],
            editedIndex: -1,
            deleteIndex:-1,
            editedItem: {
                name: '',
                price:1000,
                disc:0,
                id_menucategory:1,
                image:'',
                description: '',
            },
            defaultItem: {
                name: '',
                price:1000,
                disc:0,
                id_menucategory:1,
                image:'',
                description: '',
            },
            dialog: false, 
            dialogDelete:false,
            file_upload:''

        }),
        watch: {

            dialog (val) {
                val || this.close()
            },

        },
        mounted (){
            
        },
        created() {
            this.loadMenuList();
            this.loadMenuCategories();
            this.loadSupportOnlines();
        },
        methods: {
            onFileChanged(){                
                if (!event.target.files.length) return;
                this.editedItem.image = event.target.files[0];
            },
            onCheckChanged(){                
                console.log(this.supportojol)
                // if (!event.target.files.length) return;
                // this.editedItem.image = event.target.files[0];
            },
            loadMenuList(url){
                url = url || 'admin/menu/list';
                this.$store.dispatch('menu/ACT_LOADMENUS', url)
            },
            loadMenuCategories(url){
                url = url || 'admin/menu-category/list';
                this.$store.dispatch('menucategories/ACT_LOADMENUCATEGORIES', url)
            },
            loadSupportOnlines(url){
                url = url || 'support-ojol/list';
                this.$store.dispatch('supportonline/ACT_LOADSUPPORTONLINES', url)
            },
            save () {

                this.btnLoading = true

                if (this.editedIndex > -1) {

                    let formData = new FormData();
                    formData.append('id', this.editedItem.id);
                    formData.append('name', this.editedItem.name);
                    formData.append('id_category', this.editedItem.id_menucategory);
                    formData.append('price', this.editedItem.price);
                    formData.append('disc', this.editedItem.disc);
                    formData.append('pic', this.editedItem.image);
                    formData.append('description', this.editedItem.description);

                    for (let i = 0; i < this.supportojol.length; i++) {
                        if (this.supportojol[i] == 1){
                            formData.append('markup_gofood', 1);
                        } else if(this.supportojol[i] == 2){
                            formData.append('markup_grabfood', 2);
                        }
                    }
                    
                    this.$store.dispatch('menu/ACT_UPDATE', formData)
                    .then(res =>{
                        console.log(res)
                        toast.fire({
                            type: 'success',
                            title: "Success Updated Table"
                        });
                    })
                    .catch(err => {
                        console.log(err)
                        toast.fire({
                            type: 'error',
                            title: err
                        });
                    })
                    .finally(()=>{
                        this.btnLoading = false
                        this.close()
                    });
                    
                } else {

                    //if(this.$refs.form.validate()) { 
                        
                        let formData = new FormData();

                        formData.append('name', this.editedItem.name);
                        formData.append('id_category', this.editedItem.id_menucategory);
                        formData.append('price', this.editedItem.price);
                        formData.append('disc', this.editedItem.disc);
                        formData.append('pic', this.editedItem.image);
                        formData.append('description', this.editedItem.description);
                        
                        for (let i = 0; i < this.supportojol.length; i++) {
                            
                            if (this.supportojol[i] == 1){
                                formData.append('markup_gofood', 1);
                            } else if(this.supportojol[i] == 2){
                                formData.append('markup_grabfood', 2);
                            }

                        }

                        this.$store.dispatch('menu/ACT_SAVE', formData)
                        .then(res =>{
                            toast.fire({
                                type: 'success',
                                title: "Success Created Menu"
                            });
                        })
                        .catch(err => {
                            toast.fire({
                                type: 'error',
                                title: err
                            });
                        })
                        .finally(()=>{
                            this.btnLoading = false
                            this.close()
                        });
                    //}
                }
                
            },
            addItem(){
                this.dialog = true
            },
            editItem(item){
                
                this.editedIndex = this.itemsmenus.indexOf(item)
                // this.editedItem = Object.assign({}, item)

                if(item.markup_gofood > 0) {
                    this.supportojol.push(item.markup_gofood)
                }

                if(item.markup_grabfood > 0) {
                    this.supportojol.push(item.markup_grabfood)
                }
                
                this.editedItem= {
                    id:item.id,
                    name: item.name,
                    price:item.price,
                    disc:item.disc,
                    id_menucategory:parseInt(item.id_category),
                    description: item.description,
                }

                setTimeout(()=>{
                    this.dialog = true
                },500);

            },
            deleteItem(item, value) {
                const deleteIndex = this.itemsmenus.indexOf(item)
                this.itemTemp = item
                
                if(value == "ok"){
                    this.btnLoading = true
                    this.$store.dispatch('menu/ACT_DELETED', {
                        index: deleteIndex,
                        id:item.id
                    })
                        .then(res =>{
                            toast.fire({
                                type: 'success',
                                title: "Success Deleted Table"
                            });
                        })
                        .catch(err => {
                            toast.fire({
                                type: 'error',
                                title: err
                            });
                        })
                        .finally(()=>{
                            this.btnLoading = false
                            this.dialogDelete = false
                            this.close()
                        });
                } else {
                    this.dialogDelete = true
                }
                
                // confirm('Are you sure you want to delete this item?') && this.itemtables.splice(index, 1)
            },
            close () {
                //console.log(this.$refs.form.value)
                // this.$refs.form.reset()
                this.editedItem = Object.assign({}, this.defaultItem)
                this.supportojol=[]
                this.editedIndex = -1
                this.dialog = false
            },
        },
        computed:{
            itemsmenus () {
                return this.$store.state.menu.listmenus
            },
            itemmenucategories(){
                return this.$store.state.menucategories.listmenucategories
            },
            itemsupportonlines(){
                return this.$store.state.supportonline.listsupportonlines
            },
            formTitle () {
                return this.editedIndex === -1 ? 'Tambah Data' : 'Edit Data'
            },
            formBtnTitle () {
                return this.editedIndex === -1 ? 'Simpan' : 'Update'
            },
        }

    }
</script>